O = 35;
Q = 9;

% "true" parameters
%prior0 = normalise(rand(Q,1));
%transmat0 = mk_stochastic(rand(Q,Q));
%obsmat0 = mk_stochastic(rand(Q,O));

% training data
%T = 5;
%nex = 10;
%data1 = dhmm_sample(prior0, transmat0, obsmat0, T, nex);

% initial guess of parameters
prior1 = normalise(rand(Q,1));
transmat1 = mk_stochastic(rand(Q,Q));
obsmat1 = mk_stochastic(rand(Q,O));

%data1 = rand(8,2,10);

%data=[]
%for i=1:10
%data{1,i} = data1(:,:,i);
%end
data_c = [];
data_g = [];
data_h = [];
data_v = [];

n_c = 25;
n_g = 20;
n_h = 20;
n_v = 20;

data_c(:,1) = top_n(n_c,'csv data\c1.txt');
data_c(:,2) = top_n(n_c,'csv data\c2.txt');
data_c(:,3) = top_n(n_c,'csv data\c3.txt');
data_c(:,4) = top_n(n_c,'csv data\c4.txt');
data_c(:,5) = top_n(n_c,'csv data\c5.txt');
data_c(:,6) = top_n(n_c,'csv data\c6.txt');

data_g(:,1) = top_n(n_g,'csv data\g1.txt');
data_g(:,2) = top_n(n_g,'csv data\g2.txt');
data_g(:,3) = top_n(n_g,'csv data\g3.txt');
data_g(:,4) = top_n(n_g,'csv data\g4.txt');
data_g(:,5) = top_n(n_g,'csv data\g5.txt');
data_g(:,6) = top_n(n_g,'csv data\g6.txt');

data_h(:,1) = top_n(n_h,'csv data\h1.txt');
data_h(:,2) = top_n(n_h,'csv data\h2.txt');
data_h(:,3) = top_n(n_h,'csv data\h3.txt');
data_h(:,4) = top_n(n_h,'csv data\h4.txt');
data_h(:,5) = top_n(n_h,'csv data\h5.txt');
data_h(:,6) = top_n(n_h,'csv data\h6.txt');

data_v(:,1) = top_n(n_v,'csv data\v1.txt');
data_v(:,2) = top_n(n_v,'csv data\v2.txt');
data_v(:,3) = top_n(n_v,'csv data\v3.txt');
data_v(:,4) = top_n(n_v,'csv data\v4.txt');
data_v(:,5) = top_n(n_v,'csv data\v5.txt');
data_v(:,6) = top_n(n_v,'csv data\v6.txt');


% improve guess of parameters using EM
[LL_c, prior_c, transmat_c, obsmat_c] = dhmm_em(data_c, prior1, transmat1, obsmat1, 'max_iter', 5);
[LL_g, prior_g, transmat_g, obsmat_g] = dhmm_em(data_g, prior1, transmat1, obsmat1, 'max_iter', 5);
[LL_h, prior_h, transmat_h, obsmat_h] = dhmm_em(data_h, prior1, transmat1, obsmat1, 'max_iter', 5);
[LL_v, prior_v, transmat_v, obsmat_v] = dhmm_em(data_v, prior1, transmat1, obsmat1, 'max_iter', 5);
%LL_c

RESULT = [] ;

data_test = top_n(20,'csv data\c7.txt');

data_c_ext = extracted(data_c,data_test,n_c);
data_g_ext = extracted(data_g,data_test,n_g);
data_h_ext = extracted(data_h,data_test,n_h);
data_v_ext = extracted(data_v,data_test,n_v);

% use model to compute log likelihood
loglik_c = dhmm_logprob(data_c_ext, prior_c, transmat_c, obsmat_c);
loglik_g = dhmm_logprob(data_g_ext, prior_g, transmat_g, obsmat_g);
loglik_h = dhmm_logprob(data_h_ext, prior_h, transmat_h, obsmat_h);
loglik_v = dhmm_logprob(data_v_ext, prior_v, transmat_v, obsmat_v);
% log lik is slightly different than LL(end), since it is computed after the final M step

RESULT(:,1) = [loglik_c loglik_g loglik_h loglik_v];

data_test = top_n(20,'csv data\c8.txt');

data_c_ext = extracted(data_c,data_test,n_c);
data_g_ext = extracted(data_g,data_test,n_g);
data_h_ext = extracted(data_h,data_test,n_h);
data_v_ext = extracted(data_v,data_test,n_v);

% use model to compute log likelihood
loglik_c = dhmm_logprob(data_c_ext, prior_c, transmat_c, obsmat_c);
loglik_g = dhmm_logprob(data_g_ext, prior_g, transmat_g, obsmat_g);
loglik_h = dhmm_logprob(data_h_ext, prior_h, transmat_h, obsmat_h);
loglik_v = dhmm_logprob(data_v_ext, prior_v, transmat_v, obsmat_v);

RESULT(:,2) = [loglik_c loglik_g loglik_h loglik_v];


data_test = top_n(20,'csv data\g7.txt');

data_c_ext = extracted(data_c,data_test,n_c);
data_g_ext = extracted(data_g,data_test,n_g);
data_h_ext = extracted(data_h,data_test,n_h);
data_v_ext = extracted(data_v,data_test,n_v);

% use model to compute log likelihood
loglik_c = dhmm_logprob(data_c_ext, prior_c, transmat_c, obsmat_c);
loglik_g = dhmm_logprob(data_g_ext, prior_g, transmat_g, obsmat_g);
loglik_h = dhmm_logprob(data_h_ext, prior_h, transmat_h, obsmat_h);
loglik_v = dhmm_logprob(data_v_ext, prior_v, transmat_v, obsmat_v);

RESULT(:,3) = [loglik_c loglik_g loglik_h loglik_v];


data_test = top_n(20,'csv data\g8.txt');

data_c_ext = extracted(data_c,data_test,n_c);
data_g_ext = extracted(data_g,data_test,n_g);
data_h_ext = extracted(data_h,data_test,n_h);
data_v_ext = extracted(data_v,data_test,n_v);

% use model to compute log likelihood
loglik_c = dhmm_logprob(data_c_ext, prior_c, transmat_c, obsmat_c);
loglik_g = dhmm_logprob(data_g_ext, prior_g, transmat_g, obsmat_g);
loglik_h = dhmm_logprob(data_h_ext, prior_h, transmat_h, obsmat_h);
loglik_v = dhmm_logprob(data_v_ext, prior_v, transmat_v, obsmat_v);

RESULT(:,4) = [loglik_c loglik_g loglik_h loglik_v];


data_test = top_n(20,'csv data\h7.txt');

data_c_ext = extracted(data_c,data_test,n_c);
data_g_ext = extracted(data_g,data_test,n_g);
data_h_ext = extracted(data_h,data_test,n_h);
data_v_ext = extracted(data_v,data_test,n_v);

% use model to compute log likelihood
loglik_c = dhmm_logprob(data_c_ext, prior_c, transmat_c, obsmat_c);
loglik_g = dhmm_logprob(data_g_ext, prior_g, transmat_g, obsmat_g);
loglik_h = dhmm_logprob(data_h_ext, prior_h, transmat_h, obsmat_h);
loglik_v = dhmm_logprob(data_v_ext, prior_v, transmat_v, obsmat_v);

RESULT(:,5) = [loglik_c loglik_g loglik_h loglik_v];


data_test = top_n(20,'csv data\h8.txt');

data_c_ext = extracted(data_c,data_test,n_c);
data_g_ext = extracted(data_g,data_test,n_g);
data_h_ext = extracted(data_h,data_test,n_h);
data_v_ext = extracted(data_v,data_test,n_v);

% use model to compute log likelihood
loglik_c = dhmm_logprob(data_c_ext, prior_c, transmat_c, obsmat_c);
loglik_g = dhmm_logprob(data_g_ext, prior_g, transmat_g, obsmat_g);
loglik_h = dhmm_logprob(data_h_ext, prior_h, transmat_h, obsmat_h);
loglik_v = dhmm_logprob(data_v_ext, prior_v, transmat_v, obsmat_v);

RESULT(:,6) = [loglik_c loglik_g loglik_h loglik_v];


data_test = top_n(20,'csv data\v7.txt');

data_c_ext = extracted(data_c,data_test,n_c);
data_g_ext = extracted(data_g,data_test,n_g);
data_h_ext = extracted(data_h,data_test,n_h);
data_v_ext = extracted(data_v,data_test,n_v);

% use model to compute log likelihood
loglik_c = dhmm_logprob(data_c_ext, prior_c, transmat_c, obsmat_c);
loglik_g = dhmm_logprob(data_g_ext, prior_g, transmat_g, obsmat_g);
loglik_h = dhmm_logprob(data_h_ext, prior_h, transmat_h, obsmat_h);
loglik_v = dhmm_logprob(data_v_ext, prior_v, transmat_v, obsmat_v);

RESULT(:,7) = [loglik_c loglik_g loglik_h loglik_v];


data_test = top_n(20,'csv data\v8.txt');

data_c_ext = extracted(data_c,data_test,n_c);
data_g_ext = extracted(data_g,data_test,n_g);
data_h_ext = extracted(data_h,data_test,n_h);
data_v_ext = extracted(data_v,data_test,n_v);

% use model to compute log likelihood
loglik_c = dhmm_logprob(data_c_ext, prior_c, transmat_c, obsmat_c);
loglik_g = dhmm_logprob(data_g_ext, prior_g, transmat_g, obsmat_g);
loglik_h = dhmm_logprob(data_h_ext, prior_h, transmat_h, obsmat_h);
loglik_v = dhmm_logprob(data_v_ext, prior_v, transmat_v, obsmat_v);

RESULT(:,8) = [loglik_c loglik_g loglik_h loglik_v];


RESULT


